#include "puzzle.h"

int *puzzle_1 = (int []){
  NORMALIZE, 1, 2, 3,
  CUBE, 0,   /* no constraint */
  CUBE, 1,   TOUCH, 0,
  CUBE, 2,   TOUCH, 1, ALIGNED, 0, 1,
  CUBE, 3,   TOUCH, 2, NOT_ALIGNED, 1, 2,
  CUBE, 4,   TOUCH, 3, NOT_ALIGNED, 2, 3,
  CUBE, 5,   TOUCH, 4, NOT_ALIGNED, 3, 4,
  CUBE, 6,   TOUCH, 5, ALIGNED, 4, 5,
  CUBE, 7,   TOUCH, 6, NOT_ALIGNED, 5, 6,
  CUBE, 8,   TOUCH, 7, NOT_ALIGNED, 6, 7,
  CUBE, 9,   TOUCH, 8, ALIGNED, 7, 8,
  CUBE, 10,  TOUCH, 9, NOT_ALIGNED, 8, 9,
  CUBE, 11,  TOUCH, 10, NOT_ALIGNED, 9, 10,
  CUBE, 12,  TOUCH, 11, NOT_ALIGNED, 10, 11,
  CUBE, 13,  TOUCH, 12, ALIGNED, 11, 12,
  CUBE, 14,  TOUCH, 13, NOT_ALIGNED, 12, 13,
  CUBE, 15,  TOUCH, 14, ALIGNED, 13, 14,
  CUBE, 16,  TOUCH, 15, NOT_ALIGNED, 14, 15,
  CUBE, 17,  TOUCH, 16, NOT_ALIGNED, 15, 16,
  CUBE, 18,  TOUCH, 17, NOT_ALIGNED, 16, 17,
  CUBE, 19,  TOUCH, 18, NOT_ALIGNED, 17, 18,
  CUBE, 20,  TOUCH, 19, ALIGNED, 18, 19,
  CUBE, 21,  TOUCH, 20, NOT_ALIGNED, 19, 20,
  CUBE, 22,  TOUCH, 21, ALIGNED, 20, 21,
  CUBE, 23,  TOUCH, 22, NOT_ALIGNED, 21, 22,
  CUBE, 24,  TOUCH, 23, ALIGNED, 22, 23,
  CUBE, 25,  TOUCH, 24, NOT_ALIGNED, 23, 24,
  CUBE, 26,  TOUCH, 25, ALIGNED, 24, 25,
  -1
};

int *puzzle_2 = (int []){
  NORMALIZE, 1, 2, 3,
  CUBE, 0,   /* no constraint */
  CUBE, 1,   TOUCH, 0,
  CUBE, 2,   TOUCH, 1, ALIGNED, 0, 1,
  CUBE, 3,   TOUCH, 2, NOT_ALIGNED, 1, 2,
  CUBE, 4,   TOUCH, 3, NOT_ALIGNED, 2, 3,
  CUBE, 5,   TOUCH, 4, NOT_ALIGNED, 3, 4,
  CUBE, 6,   TOUCH, 5, NOT_ALIGNED, 4, 5,
  CUBE, 7,   TOUCH, 6, ALIGNED, 5, 6,
  CUBE, 8,   TOUCH, 7, NOT_ALIGNED, 6, 7,
  CUBE, 9,   TOUCH, 8, NOT_ALIGNED, 7, 8,
  CUBE, 10,  TOUCH, 9, NOT_ALIGNED, 8, 9,
  CUBE, 11,  TOUCH, 10, NOT_ALIGNED, 9, 10,
  CUBE, 12,  TOUCH, 11, NOT_ALIGNED, 10, 11,
  CUBE, 13,  TOUCH, 12, NOT_ALIGNED, 11, 12,
  CUBE, 14,  TOUCH, 13, NOT_ALIGNED, 12, 13,
  CUBE, 15,  TOUCH, 14, NOT_ALIGNED, 13, 14,
  CUBE, 16,  TOUCH, 15, ALIGNED, 14, 15,
  CUBE, 17,  TOUCH, 16, NOT_ALIGNED, 15, 16,
  CUBE, 18,  TOUCH, 17, ALIGNED, 16, 17,
  CUBE, 19,  TOUCH, 18, NOT_ALIGNED, 17, 18,
  CUBE, 20,  TOUCH, 19, ALIGNED, 18, 19,
  CUBE, 21,  TOUCH, 20, NOT_ALIGNED, 19, 20,
  CUBE, 22,  TOUCH, 21, ALIGNED, 20, 21,
  CUBE, 23,  TOUCH, 22, NOT_ALIGNED, 21, 22,
  CUBE, 24,  TOUCH, 23, NOT_ALIGNED, 22, 23,
  CUBE, 25,  TOUCH, 24, NOT_ALIGNED, 23, 24,
  CUBE, 26,  TOUCH, 25, ALIGNED, 24, 25,
  -1
};

int *puzzle_3 = (int []){
  NORMALIZE, 0, 1, 2,
/* piece 1 */
/*
 * 0
 * 1 2
 */
  CUBE, 0,
  CUBE, 1,  TOUCH, 0,
  CUBE, 2,  TOUCH, 1, NOT_ALIGNED, 0, 1, ORDER, 0, 2,
/* piece 2 */
/* start cube 3
 * 0
 * 1 2 3
 */
  CUBE, 3+0,
  CUBE, 3+1,  TOUCH, 3+0,
  CUBE, 3+2,  TOUCH, 3+1, NOT_ALIGNED, 3+0, 3+1,
  CUBE, 3+3,  TOUCH, 3+2, ALIGNED, 3+1, 3+2,
/* piece 3 */
/* start cube 7
 * 0 1 2
 *   3
 */
  CUBE, 7+0,
  CUBE, 7+1,  TOUCH, 7+0,
  CUBE, 7+2,  TOUCH, 7+1, ALIGNED, 7+0, 7+1, ORDER, 7+0, 7+2,
  CUBE, 7+3,  TOUCH, 7+1, NOT_ALIGNED, 7+0, 7+1,
/* piece 4 */
/* start cube 11
 *   2 3
 * 0 1
 */
  CUBE, 11+0,
  CUBE, 11+1,  TOUCH, 11+0,
  CUBE, 11+2,  TOUCH, 11+1, NOT_ALIGNED, 11+0, 11+1,
  CUBE, 11+3,  TOUCH, 11+2, VEC, 11+0, 11+1, 11+2, ORDER, 11+0, 11+3,
/* piece 5 */
/* start cube 15
 *    3
 *   2
 * 0 1
 */
  CUBE, 15+0,
  CUBE, 15+1,  TOUCH, 15+0,
  CUBE, 15+2,  TOUCH, 15+1, NOT_ALIGNED, 15+0, 15+1,
  CUBE, 15+3,  TOUCH, 15+2, LEFT, 15+1, 15+2, 15+0, 15+2, ORDER, 15+0, 15+3,
/* piece 6 */
/* start cube 19
 * 3
 *  1 2
 *  0
 */
  CUBE, 19+0,
  CUBE, 19+1,  TOUCH, 19+0,
  CUBE, 19+2,  TOUCH, 19+1, NOT_ALIGNED, 19+0, 19+1, ORDER, 19+0, 19+2,
  CUBE, 19+3,  TOUCH, 19+1, LEFT, 19+1, 19+0, 19+2, 19+1, ORDER, 19+0, 19+3,
/* piece 7 */
/* start cube 23
 *    3
 * 1 2
 * 0
 */
  CUBE, 23+0,
  CUBE, 23+1,  TOUCH, 23+0,
  CUBE, 23+2,  TOUCH, 23+1, NOT_ALIGNED, 23+0, 23+1,
  CUBE, 23+3,  TOUCH, 23+2, LEFT, 23+1, 23+0, 23+2, 23+2, ORDER, 23+0, 23+3,
  -1
};
